// user-defined variables

/* mozteroidsSkin:
 * the set of images to use
 * currently valid are default and grey
 * look in chrome://mozteroids/content/images for details
 */
var mozteroidsSkin = "default";

	// player options
var playerInitialScore = 0; // the score that players start with
var playerInitialNoOfLives = 3; // the number of lives each player has
var playerInitialPosition = 3; // the intitial position of the player (0..11 'compass' points)
var playerStartingPosition; // the starting position of the players (null for center)
var playerInitialVelocity = new Vector(0,0); // the initial velocity (x and y components)
var playerMinvelocity = new Vector(-12,-12); // the minimum velocity (x and y components)
var playerMaxvelocity = new Vector(12,12); // the maximum velocity (x and y components)
var playerSpeed = 3; // the speed that which the player moves
	// asteroid options
var initialNumAsteroids = 5; // the numer of asteroids the game starts level 1 with
	// game options
var tickSpeed = 100; // the overall speed of the game
var projectileClone = true;	// the method for drawing new projectiles 
								// true: clone new projectiles (elements) each time (slower) 
								// false: reuse the same projectiles (currently not working)
var enableStickyProjectiles = true; // enable weird projectiles that stick the edge of the screen for a bit
var blankImage = "images/blank.gif";
	// constants
var DEFAULT_PROJECTILE_SPEED = new Vector(15,15); // the speed of (un-powerupped) projectiles (x and y components)
var DEFAULT_ASTEROID_SPEED = new Vector(5,5); // the speed of asteroids
var MAX_PROJECTILES = 20; // the maximum number of projectiles on screen at once (a lower number can reduce jerkiness
var DEATH_TIMEOUT = 1000; // the time before a respawn
var EXPLOSION_TIMEOUT = 500; // the time an explosion lives for
var FLASH_LENGTH = 20; // ticks to flash/invincable for at beginning of life
var USE_CIRCLE_COLLISIONS = false; // true = untested (and probably slower)
var ASTEROID_DESTROY_WAIT = 1000; // time b4 asteroid sprite is released;
var ASTEROID_COLLISION_BOUNDARY = 20; // the collision boundary for circular collisions
var ASTEROID_SQUARE_BOUNDARY = 5; // the collision boundary for square collisions
var RANDOMISE_INITIAL_ASTEROID_SIZES = true; // false = all asteroids start large
var MAX_ASTEROID_SIZE = 110; // the max asteroid gif size
var ASTEROID_EXPLOSIONS = true; // use asteroid explosions (slow) or just puff
var ASTEROID_HIT_SCORE = 100; // the score for hitting a large asteroid (smaller ones are multiples of this)
var ENABLE_FORWARD_BOOSTER = true; //animate when accerlates?
var PROJECTILE_TIMER = 3; // the minimum time between projeciles

	// strings
var packageName = "Mozteroids"; // the name of the game

	// misc options
var debug = false; // print out some debug info during the game

// internal variables

var player1;
var gameOver = true;
var gameInterval;
var playAreaWidth = 0;
var playAreaHeight = 0;
var ROUND_TO = 2;
var headProjectile;
var projectileCount = 0;
var imageDir;
var asteroidsIndex;
var tickCount;
var asteroidCount = new Array(0,0,0,0);
var projectileTimer;
var paused = false;
var defaultProjectileElem, projectilesElem, infoTextElem, defaultAsteroidElem, asteroidsElem, explosion1Elem, explosion2Elem, explosion3Elem, explosion3Elem, powerupElem, scoreElem, livesElem;

//methods

function startUp() {
	// start preloading images
	(new Image()).src = "images/" + mozteroidsSkin + "/asteroid_explosion.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/asteroid_large.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/asteroid_medium.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/asteroid_small.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/player1_0.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/player1_120.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/player1_150.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/player1_180.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/player1_210.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/player1_240.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/player1_270.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/player1_30.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/player1_300.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/player1_330.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/player1_60.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/player1_90.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/player1_explosion.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/powerup_shield.gif";
	(new Image()).src = "images/" + mozteroidsSkin + "/projectile.gif";

	// create refs to elements for quicker access later
	defaultProjectileElem=document.getElementById("default_projectile");
	//projectilesElem=document.getElementById("projectiles");
	projectilesElem=document.getElementById("main-playing-area");
	infoTextElem=document.getElementById("infotext");

	defaultAsteroidElem=document.getElementById("default_asteroid");
	asteroidsElem=document.getElementById("asteroids");
	
	explosion1Elem=document.getElementById("explosion1");
	explosion2Elem=document.getElementById("explosion2");
	explosion3Elem=document.getElementById("explosion3");
	explosion4Elem=document.getElementById("explosion4");

	powerupElem=document.getElementById("powerup");

	scoreElem=document.getElementById("score");
	livesElem=document.getElementById("lives");

	var tempElem;
	if (!projectileClone) {
		for (var i=0; i<MAX_PROJECTILES+1; i++) {
			tempElem = defaultProjectileElem.cloneNode(false)
			tempElem.setAttribute("id","projectile"+i);
			//tempElem.setAttribute("class","hidden");
		    projectilesElem.appendChild(tempElem);
		}
	}
	headProjectile = new Projectile(new Vector(0,0),new Vector(0,0),null);

	asteroidsIndex = new Array(initialNumAsteroids*2);
	for (var i=0; i<initialNumAsteroids*2; i++) {
		tempElem = defaultAsteroidElem.cloneNode(false);
		tempElem.setAttribute("id","asteroid"+i);
		asteroidsElem.appendChild(tempElem);
		asteroidsIndex[i]=null;
	}
	
	playAreaWidth = parseInt(document.getElementById("main-playing-area").getAttribute("width"));
	playAreaHeight = parseInt(document.getElementById("main-playing-area").getAttribute("height"));
	imageDir = "images/"+mozteroidsSkin+"/";

	player1 = new Player();
	player1.left=(playAreaWidth-player1.width)/2;
	player1.sprite.setAttribute("left",player1.left);
	player1.top=(playAreaHeight-player1.height)/2;
	player1.sprite.setAttribute("top",player1.top);
	player1.isDead = true;

	//defaultAsteroidElem.setAttribute("src",imageDir+"asteroid_large_explosion.gif");
	tickCount=0;

	if (debug) newGame();
}

function newGame() {
	// clear out stuff
	for (var i=0; i<asteroidsIndex.length; i++) {
		destroyAsteroid(i);
	}
	// need to destoy projectiles properly...
	// by travelling the linked list...

	gameOver = false;
	paused = false;
    player1.score = playerInitialScore;
	scoreElem.setAttribute("value",player1.score);
    player1.lives = playerInitialNoOfLives;
	livesElem.setAttribute("value",player1.lives);
	newLife();
	projectileTimer = 0;
	gameInterval = setInterval("gameTick()",tickSpeed);
	
	// create the asteroids
	for (var i=0; i<initialNumAsteroids; i++) {
		spawnNewEdgeAsteroid(i);
	}

}

function accelerate(by) {
	if (player1.isDead) return;

	if (by==null)  {
		by = player1.positions[player1.position];
		//player1.sprite.removeAttribute("src");
		if (ENABLE_FORWARD_BOOSTER) {
			player1.sprite.setAttribute("src",blankImage);
			player1.sprite.setAttribute("src",by.image);
		}
	}
	
	//player1.velocity.x=floorTo(player1.velocity.x+by.x,ROUND_TO);
	//player1.velocity.y=floorTo(player1.velocity.y+by.y,ROUND_TO);
	player1.velocity.x=player1.velocity.x+(by.x*playerSpeed);
	player1.velocity.y=player1.velocity.y+(by.y*playerSpeed);

	if (player1.velocity.x>playerMaxvelocity.x) player1.velocity.x=playerMaxvelocity.x
	if (player1.velocity.x<playerMinvelocity.x) player1.velocity.x=playerMinvelocity.x
	if (player1.velocity.y>playerMaxvelocity.y) player1.velocity.y=playerMaxvelocity.y;
	if (player1.velocity.y<playerMinvelocity.y) player1.velocity.y=playerMinvelocity.y;

}

function decelerate(by) {
	if (gameOver) return;

	accelerate(new Vector(-player1.positions[player1.position].x,-player1.positions[player1.position].y));

}

function moveForward() {

	if (player1.left<-player1.width) player1.left = playAreaWidth;
	if (player1.left>playAreaWidth) player1.left = -player1.width;
	player1.left = player1.left + player1.velocity.x;
	player1.sprite.setAttribute("left",player1.left);
	if (player1.isPoweredup) powerupElem.setAttribute("left",player1.left);

	if (player1.top<-player1.height) player1.top = playAreaHeight;
	if (player1.top>playAreaHeight) player1.top = -player1.height;
	player1.top = player1.top - player1.velocity.y;
	player1.sprite.setAttribute("top",player1.top);
	if (player1.isPoweredup) powerupElem.setAttribute("top",player1.top);
}

function rotateRight() {
	if (player1.isDead) return;

	player1.position--;
	if (player1.position < 0) player1.position = player1.positions.length-1;
	player1.sprite.setAttribute("src",player1.positions[player1.position].image);
}

function rotateLeft() {
	if (player1.isDead) return;

	player1.position++;
	if (player1.position > player1.positions.length-1) player1.position = 0;
	player1.sprite.setAttribute("src",player1.positions[player1.position].image);
}

function fire() {
	if (gameOver) return;

	if (player1.isDead) return;
	//if ((document.getElementById("projectiles").childNodes.length-1)>=MAX_PROJECTILES)
	if (projectileCount>=MAX_PROJECTILES)
	{
		mdump("max projectiles reached");
		return;
	}

	if (projectileTimer<0) {

		var tmpProj = new Projectile(
			new Vector(player1.positions[player1.position].x,player1.positions[player1.position].y),
			new Vector(player1.left+(player1.width/2),player1.top+(player1.height/2)),
			null);
	
		headProjectile.addProjectile(tmpProj);
	
		projectileTimer=PROJECTILE_TIMER;
	}
}

function die() {
	if (gameOver) return;
	
	if (player1.flashCount>0||player1.isDead) return;

	if (player1.lives==0) {
		gameOverMan();
	} else {
		player1.lives--;
		livesElem.setAttribute("value",player1.lives);
		clearPowerup();
		player1.sprite.setAttribute("src",imageDir+"player1_explosion.gif");
		player1.isDead = true;
	
		setTimeout("newLife()",DEATH_TIMEOUT);
	}
}

function newLife() {

	player1.init();
	setInfoText("Go!");
	setTimeout("setInfoText('')",1000);
}

function pause() {
	if (paused) {
		// unpause
		gameInterval = setInterval("gameTick()",tickSpeed);
		gameOver = false;
		player1.isDead = false;
		paused = false
		setInfoText("");
	} else if (!gameOver&&!player1.isDead) {
		// pause
		setInfoText("Paused");
		clearInterval(gameInterval);
		gameOver = true;
		player1.isDead = true;
		paused = true;
	}
}

function spaceKey() {
    if (gameOver==true&&paused==false) {
        newGame();
    } else {
        fire();
    }
}

function keyPress(key) {
	if (key==104) open('help.xul','blank','chrome,modal,centerscreen');

	if (!debug) return;

	// debugger keys
	if (key>64) mdump("you pressed: "+key);
	if (key==115) { // 's' for stop
		player1.velocity.x=0;
		player1.velocity.y=0;
	} else if (key==100) { // 'd' for die
		die();
	} else if (key==105) { // 'i' for invincable (for a bit)
		player1.flashCount=1000000;
		setPowerup(1,"shield");
	} else if (key==110) { // 'n' for new game
	} else if (key==111) { // 'o' for options
		openDialog('options.xul','blank','chrome,modal')
	} else if (key==114) { // 'r' for restart game
		gameOverMan();
		newGame();
	} else if (key==113) { // 'q' for quill asteroid
		asteroidsIndex[0].hit(headProjectile.nextProjectile.velocity);
	} else {
	}
		
}

// for the moment, player1tick is the main game tick
function gameTick() {
	//tickCount++;
	//mdump(tickCount);

	projectileTimer--;
	
	if (player1.flashCount>0) player1.flashCount--; 
		else if (player1.flashCount==0) clearPowerup();
	//uncomment any of the following for nasty debugging info
	//mdump("player1: velocity.x="+player1.velocity.x+", velocity.y="+player1.velocity.y);
	//mdump("projectile count: "+projectileCount);
	//mdump("max asteroid count: "+asteroidsIndex.length);
	//mdump("asteroids: "+asteroidCount[3]+" large, "+asteroidCount[2]+" medium, "+asteroidCount[1]+" small, "+asteroidCount[0]+" none.");

	// move player 1
	moveForward();

	// move projectiles
	headProjectile.moveProjectiles();

	// move asteroids
	for (var i=0; i<asteroidsIndex.length; i++) {
		if (asteroidsIndex[i]!=null) { 
			asteroidsIndex[i].moveAsteroid();
		}
	}

}

function gameOverMan() {
	gameOver=true;
	player1.isDead = true;
	paused=false;
	clearPowerup();
	player1.sprite.setAttribute("src",imageDir+"player1_explosion.gif");
	setTimeout("player1.sprite.setAttribute('src',blankImage);",3000);
	if (gameInterval>-1) clearInterval(gameInterval);
	setInfoText("Game Over");
}

// util functions

function setInfoText(text) {
	infoTextElem.setAttribute("value",text);
}

function mdump(text) {
	if (debug) window.dump(packageName+": "+text+"\n");
}

function floorTo(num, decplaces) {
	num = num*(10^decplaces);
	num = Math.floor(num);
	num = num/(10^decplaces);
	return num;
}

//classes

function Player() {
	this.score = playerInitialScore;
	this.lives = playerInitialNoOfLives;
	this.gameOver = false;
	this.sprite = document.getElementById("player1");
	this.width = parseInt(this.sprite.getAttribute("width"));
	this.height = parseInt(this.sprite.getAttribute("height"));
	if (playerStartingPosition!=null) 
		this.startingPosition = playerStartingPosition;
	else 
		this.startingPosition = new Vector((playAreaWidth-this.width)/2,(playAreaHeight-this.height)/2);
	this.positions = [
	    new SpritePosition("player1_0.gif",1,0),
		new SpritePosition("player1_30.gif",0.86,0.5),
		new SpritePosition("player1_60.gif",0.5,0.86),
	    new SpritePosition("player1_90.gif",0,1),
		new SpritePosition("player1_120.gif",-0.5,0.86),
		new SpritePosition("player1_150.gif",-0.86,0.5),
	    new SpritePosition("player1_180.gif",-1,0),
		new SpritePosition("player1_210.gif",-0.86,-0.5),
		new SpritePosition("player1_240.gif",-0.5,-0.86),
	    new SpritePosition("player1_270.gif",0,-1),
		new SpritePosition("player1_300.gif",0.5,-0.86),
		new SpritePosition("player1_330.gif",0.86,-0.5)];
	this.init = player_init;
	//this.init();
}
function player_init() {
	this.velocity = new Vector(playerInitialVelocity.x,playerInitialVelocity.y);
	this.position = playerInitialPosition; 

    this.sprite.setAttribute("left",this.startingPosition.x);
    this.sprite.setAttribute("top",this.startingPosition.y);
    this.left = this.startingPosition.x;
    this.top = this.startingPosition.y;

	this.sprite.setAttribute("src",this.positions[this.position].image);

	this.isDead = false;
    this.flashCount = FLASH_LENGTH;
	this.isPoweredup = false;

	setPowerup("shield");
}

function SpritePosition(imageFilename, xCoeff, yCoeff) {
	this.image = imageDir+imageFilename;
	this.x = xCoeff;
	this.y = yCoeff;
}

function Vector(xCoeff, yCoeff) {
	this.x = xCoeff;
	this.y = yCoeff;
}

function Projectile(velocity, origin, type) {
	this.velocity = velocity;
	this.position = origin;
	this.nextProjectile;
	this.prevProjectile;
	this.type = type;

	/* sprite stuff
	 */
	if (projectileClone) {
		this.sprite = defaultProjectileElem.cloneNode(false);
		this.sprite.removeAttribute("id");
		projectilesElem.appendChild(this.sprite);
	} else {
		if (headProjectile==null) {	
			this.sprite = projectilesElem.firstChild;
		} else {
			this.sprite = headProjectile.getNextFreeElement();
		}
		this.sprite.setAttribute("taken","true");
		//this.sprite.removeAttribute("class");
	}
	this.sprite.setAttribute("left",this.position.x);
	this.sprite.setAttribute("top",this.position.y);

	/* add power-up stuff here
	 */
	if (type==null) {
		this.speed = DEFAULT_PROJECTILE_SPEED;
		this.sprite.setAttribute("src",imageDir+"projectile.gif");
	}

	if (enableStickyProjectiles) {
		this.width = 0;
		this.height = 0;
	} else {
		this.width = parseInt(this.sprite.getAttribute("width"));
		this.height = parseInt(this.sprite.getAttribute("height"));
	}

	/* methods
	 */
	this.addProjectile = Projectile_addProjectile;
	this.moveProjectiles = Projectile_moveProjectiles;
	this.kill = Projectile_killProjectile;
	this.getNextFreeElement = Projectile_getNextFreeElement;
}
function Projectile_addProjectile(p) {
	if (this.nextProjectile==null) {
		this.nextProjectile=p;
		p.prevProjectile=this;
		projectileCount++;
	} else {
		this.nextProjectile.addProjectile(p);
	}
}
function Projectile_moveProjectiles() {
	if (this!=headProjectile) {
		this.position.x = this.position.x + (this.velocity.x*this.speed.x);
		this.position.y = this.position.y - (this.velocity.y*this.speed.y);

		/* add collision detection in here
		 */
		//if (USE_CIRCLE_COLLISIONS) {
			//TODO
		//} else 
		{
			var theAst;
			for (var i=0; i<asteroidsIndex.length; i++) {
				theAst=asteroidsIndex[i];
				if (theAst!=null) {
					if (
						(this.position.x>theAst.position.x)&&
						(this.position.x<theAst.position.x+theAst.size.x)&&
						(this.position.y>theAst.position.y)&&
						(this.position.y<theAst.position.y+theAst.size.y)) {
						theAst.hit(this.velocity);
						this.sprite.removeAttribute("src");
						this.kill();
					}
				}
			}
		}

		this.sprite.setAttribute("left",this.position.x);
		this.sprite.setAttribute("top",this.position.y);

		if ((this.position.x<(0-this.width))||
			(this.position.x>(playAreaWidth+this.width))||
			(this.position.y<(0-this.height))||
			(this.position.y>(playAreaHeight+this.height))) 
				this.kill();
	}

	if (this.nextProjectile==null) {
		return;
	} else {
		this.nextProjectile.moveProjectiles();
	}
}
function Projectile_killProjectile() {
	this.prevProjectile.nextProjectile = this.nextProjectile;
	if (this.nextProjectile!=null) this.nextProjectile.prevProjectile = this.prevProjectile;
	projectileCount--;
	if (projectileClone) {
		projectilesElem.removeChild(this.sprite);
	} else {
		this.sprite.removeAttribute("taken");
		//this.sprite.setAttribute("class","hidden");
	}
	//delete(this);
}
function Projectile_getNextFreeElement() {
	var sib = this.sprite.nextSibling;
	if (sib==null) sib=projectilesElem.firstChild;
	if (sib.getAttribute("taken")=="true") {
		return this.nextProjectile.getNextFreeElement();
	} else {	
		return sib;
	}
}

function Asteroid(velocity,origin,size) {
	this.velocity = velocity;
	this.position = origin;
	this.id = getNextFreeAsteroid();
	this.sprite = asteroidsElem.childNodes[this.id];

	this.sprite.setAttribute("left",this.position.x);
	this.sprite.setAttribute("top",this.position.y);

	this.sizeId = size;
	this.resize = Asteroid_resize;
	this.resize(this.sizeId);

	this.moveAsteroid = Asteroid_moveAsteroid;
	this.hit = Asteroid_hit;
	this.getCentre = Asteroid_centre;
}
function Asteroid_resize(size) {
	// TODO: add setAttributes to this method?
    if (size==2) {
        this.size = new Vector(60,60);
        this.sprite.setAttribute("src",imageDir+"asteroid_medium.gif");
		this.sizeId = 2;
		this.sizeString = "medium";
    } else if (size==1) {
        this.size = new Vector(40,40);
        this.sprite.setAttribute("src",imageDir+"asteroid_small.gif");
		this.sizeId = 1;
		this.sizeString = "small";
    } else {
        this.size = new Vector(110,110);
        this.sprite.setAttribute("src",imageDir+"asteroid_large.gif");
		this.sizeId = 3;
		this.sizeString = "large";
    }
	this.sprite.setAttribute("width",this.size.x);
	this.sprite.setAttribute("height",this.size.y);
}
function Asteroid_centre() {
	return new Vector(this.position.x+this.size.x/2,this.position.y+this.size.y/2);
}
function Asteroid_moveAsteroid() {

	if (this.position.x<-this.size.x) this.position.x = playAreaWidth;
	if (this.position.x>playAreaWidth) this.position.x = -this.size.x;
	if (this.position.y<-this.size.y) this.position.y = playAreaHeight;
	if (this.position.y>playAreaHeight) this.position.y = -this.size.y;

	// player1 collision detection
	if (!player1.isDead) {
		if (USE_CIRCLE_COLLISIONS) {
			var cc = this.getCentre();
			var rad = this.size.x/2-ASTEROID_COLLISION_BOUNDARY;

			var point = new Vector(player1.left,player1.top);
			var dist = Math.sqrt((point.x-cc.x)*(point.x-cc.x)+(point.y-cc.y)*(point.y-cc.y));
			if (dist<rad) { die(); this.hit(player1.velocity); }

			var point = new Vector(player1.left,player1.top+player1.height);
			var dist = Math.sqrt((point.x-cc.x)*(point.x-cc.x)+(point.y-cc.y)*(point.y-cc.y));
			if (dist<rad) { die(); this.hit(player1.velocity); }

			var point = new Vector(player1.left+player1.width,player1.top+player1.height);
			var dist = Math.sqrt((point.x-cc.x)*(point.x-cc.x)+(point.y-cc.y)*(point.y-cc.y));
			if (dist<rad) { die(); this.hit(player1.velocity); }

			var point = new Vector(player1.left+player1.width,player1.top);
			var dist = Math.sqrt((point.x-cc.x)*(point.x-cc.x)+(point.y-cc.y)*(point.y-cc.y));
			if (dist<rad) { die(); this.hit(player1.velocity); }

		} else {
			if (
				(this.position.x+this.size.x-ASTEROID_SQUARE_BOUNDARY>player1.left)&&
				(this.position.x+ASTEROID_SQUARE_BOUNDARY<player1.left+player1.width)&&
				(this.position.y+this.size.y-ASTEROID_SQUARE_BOUNDARY>player1.top)&&
				(this.position.y+ASTEROID_SQUARE_BOUNDARY<player1.top+player1.height)) {
				die();
				this.hit(player1.velocity); 
			}
		}
	}

	this.position.x = this.position.x + (this.velocity.x*DEFAULT_ASTEROID_SPEED.x);
	this.position.y = this.position.y - (this.velocity.y*DEFAULT_ASTEROID_SPEED.y);
	this.sprite.setAttribute("left",this.position.x);
	this.sprite.setAttribute("top",this.position.y);
}
function Asteroid_hit(byVector) {
	if (this.sizeString=="small") {
	} else {
		if (byVector==null) byVector=new Vector(0,0);
		var x1 = (this.velocity.x+byVector.x)*Math.random();
		var y1 = (this.velocity.y+byVector.y)*Math.random();
		var newVelocityA = new Vector(x1,y1);
		var newVelocityB = new Vector(x1,-y1);

		spawnNewAsteroid(newVelocityA,new Vector(this.position.x,this.position.y),this.sizeId-1);
		spawnNewAsteroid(newVelocityB,new Vector(this.position.x,this.position.y),this.sizeId-1);
	}
    // add score stuff here?
	increaseScore(ASTEROID_HIT_SCORE*(4-this.sizeId));
    // this.sprite.setAttribute("src",imageDir+"asteroid_"+this.sizeString+"_explosion.gif");
	this.sprite.removeAttribute('src');
	if (ASTEROID_EXPLOSIONS) makeExplosion(this.position,this.sizeString);
	destroyAsteroid(this.id);
}

function spawnNewAsteroid(velocity,origin,size) {
    var theAst = new Asteroid(velocity,origin,size);
    asteroidsIndex[theAst.id] = theAst;
	asteroidCount[size]++;
}

function spawnNewEdgeAsteroid(i) {
	if (i==null) i = Math.round(Math.random()*4);
    var theAstX;
    var theAstY;
    var theAstDX;
    var theAstDY;
    if (i%4==0) {
            theAstX=-MAX_ASTEROID_SIZE;
            theAstY=Math.round(Math.random()*playAreaHeight);
            theAstDX=1;
            theAstDY=Math.random();
    } else if (i%4==1) {
            theAstY=-MAX_ASTEROID_SIZE;
            theAstX=Math.round(Math.random()*playAreaWidth);
            theAstDY=-1;
            theAstDX=Math.random();
    } else if (i%4==2) {
            theAstX=playAreaWidth+MAX_ASTEROID_SIZE;
            theAstY=Math.round(Math.random()*playAreaHeight);
            theAstDX=-1;
            theAstDY=Math.random();
    } else {
            theAstY=playAreaHeight+MAX_ASTEROID_SIZE;
            theAstX=Math.round(Math.random()*playAreaWidth);
            theAstDY=1;
            theAstDX=Math.random();
	}
	if (RANDOMISE_INITIAL_ASTEROID_SIZES) {	
		var theSize = Math.round(Math.random()*2)+1;
	} else {
		var theSize = 3;
	}
    spawnNewAsteroid(
        new Vector(theAstDX,theAstDY),
        new Vector(theAstX,theAstY),theSize);
}

function getNextFreeAsteroid() {
	var i;
	for (i=0; i<asteroidsIndex.length; i++) {
		if (asteroidsIndex[i]==null) return i;
	}
	
	// we've run out... make a new one
	asteroidsIndex[i]=null;
	var tempElem = defaultAsteroidElem.cloneNode(false);
	tempElem.setAttribute("id","asteroid"+i);
	asteroidsElem.appendChild(tempElem);

	return i;
}

function destroyAsteroid(asteroidId) {
	if (asteroidsIndex[asteroidId]==null) return;
	asteroidCount[asteroidsIndex[asteroidId].sizeId]--;
	if (gameOver) asteroidsIndex[asteroidId].sprite.removeAttribute('src');
	asteroidsIndex[asteroidId]=null;
	// respawn if not enuf
	if ((!gameOver)&&(asteroidCount[3]<2)&&(asteroidCount[2]<4)&&(asteroidCount[1]<4))
		spawnNewEdgeAsteroid();
}

function makeExplosion(location, size) {

	explosion1Elem.setAttribute("src",blankImage);
	explosion2Elem.setAttribute("src",blankImage);
	explosion3Elem.setAttribute("src",blankImage);
	explosion4Elem.setAttribute("src",blankImage);

	explosion1Elem.setAttribute("left",location.x-(Math.random()*40));
	explosion1Elem.setAttribute("top",location.y-(Math.random()*40));
	explosion1Elem.setAttribute("src",imageDir+"asteroid_explosion.gif");

	explosion2Elem.setAttribute("left",location.x-(Math.random()*40));
	explosion2Elem.setAttribute("top",location.y-(Math.random()*40));
	explosion2Elem.setAttribute("src",imageDir+"asteroid_explosion.gif");

	explosion3Elem.setAttribute("left",location.x+(Math.random()*40));
	explosion3Elem.setAttribute("top",location.y+(Math.random()*40));
	explosion3Elem.setAttribute("src",imageDir+"asteroid_explosion.gif");

	explosion4Elem.setAttribute("left",location.x+(Math.random()*40));
	explosion4Elem.setAttribute("top",location.y+(Math.random()*40));
	explosion4Elem.setAttribute("src",imageDir+"asteroid_explosion.gif");

	// clear the explosions after x seconds
	setTimeout("clearExplosions()",EXPLOSION_TIMEOUT);
}

function clearExplosions () {
	explosion1Elem.setAttribute("src",blankImage);
	explosion2Elem.setAttribute("src",blankImage);
	explosion3Elem.setAttribute("src",blankImage);
	explosion4Elem.setAttribute("src",blankImage);

}

function setPowerup(thePowerup) {
	powerupElem.setAttribute("src",imageDir+"powerup_"+thePowerup+".gif");
	powerupElem.setAttribute("left",player1.left);
	powerupElem.setAttribute("top",player1.top);
	player1.isPoweredup=true;
}

function clearPowerup() {
	//powerupElem.setAttribute("src",blankImage);
	powerupElem.removeAttribute("src");
	player1.isPoweredup=false;
}

function increaseScore(by) {
	player1.score = player1.score + by;
	scoreElem.setAttribute("value",player1.score);
}
